--- /dev/null
+++ net/minecraft/src/ContainerPlayer.java
@@ -1,0 +1,96 @@
+package net.minecraft.src;
+
+public class ContainerPlayer extends Container {
+	public InventoryCrafting craftMatrix;
+	public IInventory craftResult;
+	public boolean isSinglePlayer;
+
+	public ContainerPlayer(InventoryPlayer var1) {
+		this(var1, true);
+	}
+
+	public ContainerPlayer(InventoryPlayer var1, boolean var2) {
+		this.craftMatrix = new InventoryCrafting(this, 2, 2);
+		this.craftResult = new InventoryCraftResult();
+		this.isSinglePlayer = false;
+		this.isSinglePlayer = var2;
+		this.addSlot(new SlotCrafting(var1.player, this.craftMatrix, this.craftResult, 0, 144, 36));
+
+		int var3;
+		int var4;
+		for(var3 = 0; var3 < 2; ++var3) {
+			for(var4 = 0; var4 < 2; ++var4) {
+				this.addSlot(new Slot(this.craftMatrix, var4 + var3 * 2, 88 + var4 * 18, 26 + var3 * 18));
+			}
+		}
+
+		for(var3 = 0; var3 < 4; ++var3) {
+			this.addSlot(new SlotArmor(this, var1, var1.getSizeInventory() - 1 - var3, 8, 8 + var3 * 18, var3));
+		}
+
+		for(var3 = 0; var3 < 3; ++var3) {
+			for(var4 = 0; var4 < 9; ++var4) {
+				this.addSlot(new Slot(var1, var4 + (var3 + 1) * 9, 8 + var4 * 18, 84 + var3 * 18));
+			}
+		}
+
+		for(var3 = 0; var3 < 9; ++var3) {
+			this.addSlot(new Slot(var1, var3, 8 + var3 * 18, 142));
+		}
+
+		this.onCraftMatrixChanged(this.craftMatrix);
+	}
+
+	public void onCraftMatrixChanged(IInventory var1) {
+		this.craftResult.setInventorySlotContents(0, CraftingManager.getInstance().findMatchingRecipe(this.craftMatrix));
+	}
+
+	public void onCraftGuiClosed(EntityPlayer var1) {
+		super.onCraftGuiClosed(var1);
+
+		for(int var2 = 0; var2 < 4; ++var2) {
+			ItemStack var3 = this.craftMatrix.getStackInSlot(var2);
+			if(var3 != null) {
+				var1.dropPlayerItem(var3);
+				this.craftMatrix.setInventorySlotContents(var2, (ItemStack)null);
+			}
+		}
+
+	}
+
+	public boolean isUsableByPlayer(EntityPlayer var1) {
+		return true;
+	}
+
+	public ItemStack getStackInSlot(int var1) {
+		ItemStack var2 = null;
+		Slot var3 = (Slot)this.slots.get(var1);
+		if(var3 != null && var3.getHasStack()) {
+			ItemStack var4 = var3.getStack();
+			var2 = var4.copy();
+			if(var1 == 0) {
+				this.func_28125_a(var4, 9, 45, true);
+			} else if(var1 >= 9 && var1 < 36) {
+				this.func_28125_a(var4, 36, 45, false);
+			} else if(var1 >= 36 && var1 < 45) {
+				this.func_28125_a(var4, 9, 36, false);
+			} else {
+				this.func_28125_a(var4, 9, 45, false);
+			}
+
+			if(var4.stackSize == 0) {
+				var3.putStack((ItemStack)null);
+			} else {
+				var3.onSlotChanged();
+			}
+
+			if(var4.stackSize == var2.stackSize) {
+				return null;
+			}
+
+			var3.onPickupFromSlot(var4);
+		}
+
+		return var2;
+	}
+}
--- net/minecraft/src/Packet6SpawnPosition.java
+++ net/minecraft/src/Packet6SpawnPosition.java
@@ -15,7 +15,7 @@
 		this.zPosition = var1.readInt();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.xPosition);
 		var1.writeInt(this.yPosition);
 		var1.writeInt(this.zPosition);
--- net/minecraft/src/Packet12PlayerLook.java
+++ net/minecraft/src/Packet12PlayerLook.java
@@ -22,10 +22,10 @@
 		super.readPacketData(var1);
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeFloat(this.yaw);
 		var1.writeFloat(this.pitch);
-		super.writePacket(var1);
+		super.writePacketData(var1);
 	}
 
 	public int getPacketSize() {
--- net/minecraft/client/Minecraft.java
+++ net/minecraft/client/Minecraft.java
@@ -8,6 +8,16 @@
 import java.awt.Frame;
 import java.awt.Graphics;
 import java.io.File;
+
+import org.lwjgl.LWJGLException;
+import org.lwjgl.input.Controllers;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.Display;
+import org.lwjgl.opengl.DisplayMode;
+import org.lwjgl.opengl.GL11;
+import org.lwjgl.util.glu.GLU;
+
 import net.minecraft.src.AxisAlignedBB;
 import net.minecraft.src.Block;
 import net.minecraft.src.EffectRenderer;
@@ -28,6 +38,7 @@
 import net.minecraft.src.GuiInventory;
 import net.minecraft.src.GuiMainMenu;
 import net.minecraft.src.GuiScreen;
+import net.minecraft.src.ItemBlock;
 import net.minecraft.src.ItemRenderer;
 import net.minecraft.src.ItemStack;
 import net.minecraft.src.LoadingScreenRenderer;
@@ -63,14 +74,6 @@
 import net.minecraft.src.Vec3D;
 import net.minecraft.src.World;
 import net.minecraft.src.WorldRenderer;
-import org.lwjgl.LWJGLException;
-import org.lwjgl.input.Controllers;
-import org.lwjgl.input.Keyboard;
-import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.Display;
-import org.lwjgl.opengl.DisplayMode;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.util.glu.GLU;
 
 public abstract class Minecraft implements Runnable {
 	public PlayerController playerController;
@@ -346,6 +349,10 @@
 				var1 = new GuiGameOver();
 			}
 
+			if(var1 instanceof GuiMainMenu) {
+				this.ingameGUI.clearChatMessages();
+			}
+
 			this.currentScreen = (GuiScreen)var1;
 			if(var1 != null) {
 				this.setIngameNotInFocus();
@@ -608,13 +615,18 @@
 	}
 
 	private void sendClickBlockToController(int var1, boolean var2) {
+		if (!var2) {
+			this.leftClickCounter = 0;
+		}
+		
 		if(!this.playerController.isInTestMode) {
 			if(var1 != 0 || this.leftClickCounter <= 0) {
 				if(var2 && this.objectMouseOver != null && this.objectMouseOver.typeOfHit == 0 && var1 == 0) {
 					int var3 = this.objectMouseOver.blockX;
 					int var4 = this.objectMouseOver.blockY;
 					int var5 = this.objectMouseOver.blockZ;
-					this.playerController.sendBlockRemoving(var3, var4, var5, this.objectMouseOver.sideHit);
+		            this.playerController.clickBlock(var3, var4, var5, this.objectMouseOver.sideHit);
+					//this.playerController.sendBlockRemoving(var3, var4, var5, this.objectMouseOver.sideHit);
 					this.effectRenderer.addBlockHitEffects(var3, var4, var5, this.objectMouseOver.sideHit);
 				} else {
 					this.playerController.resetBlockRemoving();
@@ -630,35 +642,42 @@
 				this.thePlayer.swingItem();
 			}
 
-			int var3;
+			boolean send = true;
 			if(this.objectMouseOver == null) {
 				if(var1 == 0 && !(this.playerController instanceof PlayerControllerCreative)) {
 					this.leftClickCounter = 10;
 				}
 			} else if(this.objectMouseOver.typeOfHit == 1) {
 				if(var1 == 0) {
-					this.thePlayer.attackEntity(this.objectMouseOver.entityHit);
+					this.playerController.attackEntity(this.thePlayer, this.objectMouseOver.entityHit);
 				}
 
 				if(var1 == 1) {
-					this.thePlayer.interactWithEntity(this.objectMouseOver.entityHit);
+					this.playerController.interactWithEntity(this.thePlayer, this.objectMouseOver.entityHit);
 				}
 			} else if(this.objectMouseOver.typeOfHit == 0) {
 				int var2 = this.objectMouseOver.blockX;
-				var3 = this.objectMouseOver.blockY;
+				int var3 = this.objectMouseOver.blockY;
 				int var4 = this.objectMouseOver.blockZ;
 				int var5 = this.objectMouseOver.sideHit;
-				Block var6 = Block.blocksList[this.theWorld.getBlockId(var2, var3, var4)];
+
+				Block var6 = Block.blocksList[this.theWorld.getBlockId(var3, var4, var5)];
 				if(var1 == 0) {
-					this.theWorld.extinguishFire(var2, var3, var4, this.objectMouseOver.sideHit);
+					this.theWorld.extinguishFire(this.thePlayer, var2, var3, var4, this.objectMouseOver.sideHit);
 					if(var6 != Block.bedrock || this.thePlayer.unusedMiningCooldown >= 100) {
-						this.playerController.clickBlock(var2, var3, var4, this.objectMouseOver.sideHit);
+						this.playerController.sendBlockRemoving(var2, var3, var4, this.objectMouseOver.sideHit);
 					}
+					
 				} else {
 					ItemStack var7 = this.thePlayer.inventory.getCurrentItem();
 					int var8 = var7 != null ? var7.stackSize : 0;
-					if(this.playerController.onPlayerRightClick(this.thePlayer, this.theWorld, var7, var2, var3, var4, var5)) {
-						this.thePlayer.swingItem();
+					
+					if(this.playerController.sendPlaceBlock(this.thePlayer, this.theWorld, var7, var2, var3, var4, var5)) {
+						send = false;
+					}
+					
+					if (!send || var7 != null && var7.getItem() instanceof ItemBlock) {
+						this.thePlayer.swingItem(); // TODO: swing
 					}
 
 					if(var7 == null) {
@@ -673,18 +692,10 @@
 				}
 			}
 
-			if(var1 == 1) {
+			if(send && var1 == 1) {
 				ItemStack var9 = this.thePlayer.inventory.getCurrentItem();
-				if(var9 != null) {
-					var3 = var9.stackSize;
-					ItemStack var10 = var9.useItemRightClick(this.theWorld, this.thePlayer);
-					if(var10 != var9 || var10 != null && var10.stackSize != var3) {
-						this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.currentItem] = var10;
-						this.entityRenderer.itemRenderer.resetEquippedProgress2();
-						if(var10.stackSize == 0) {
-							this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.currentItem] = null;
-						}
-					}
+				if(var9 != null && this.playerController.sendUseItem(this.thePlayer, this.theWorld, var9)) {
+					this.entityRenderer.itemRenderer.resetEquippedProgress2();
 				}
 			}
 
@@ -789,9 +800,9 @@
 	public void runTick() {
 		this.ingameGUI.updateTick();
 		this.entityRenderer.getMouseOver(1.0F);
-		if(this.thePlayer != null) {
-			this.thePlayer.onPlayerUpdate();
-		}
+//		if(this.thePlayer != null) {
+//			this.thePlayer.onUpdate();
+//		}
 
 		if(!this.isGamePaused && this.theWorld != null) {
 			this.playerController.onUpdate();
@@ -869,13 +880,18 @@
 												if(Keyboard.getEventKey() == Keyboard.KEY_F5) {
 													this.options.thirdPersonView = !this.options.thirdPersonView;
 												}
+												
+												if(Keyboard.getEventKey() == Keyboard.KEY_J) {
+													this.options.accept62 = !this.options.accept62;
+													System.out.println("TOGGLED 62! " + this.options.accept62);
+												}
 
 												if(Keyboard.getEventKey() == this.options.keyBindInventory.keyCode) {
-													this.displayGuiScreen(new GuiInventory(this.thePlayer.inventory, this.thePlayer.inventory.craftingInventory));
+													this.displayGuiScreen(new GuiInventory(this.thePlayer));
 												}
 
 												if(Keyboard.getEventKey() == this.options.keyBindDrop.keyCode) {
-													this.thePlayer.dropPlayerItemWithRandomChoice(this.thePlayer.inventory.decrStackSize(this.thePlayer.inventory.currentItem, 1), false);
+													this.thePlayer.dropCurrentItem();
 												}
 
 												if(this.isMultiplayerWorld() && Keyboard.getEventKey() == this.options.keyBindChat.keyCode) {
@@ -1113,7 +1129,9 @@
 
 	public void respawn() {
 		this.theWorld.setSpawnLocation();
+		int var8 = 0;
 		if(this.thePlayer != null) {
+			var8 = this.thePlayer.entityID;
 			this.theWorld.setEntityDead(this.thePlayer);
 		}
 
@@ -1122,8 +1140,12 @@
 		this.playerController.flipPlayer(this.thePlayer);
 		this.theWorld.spawnPlayerWithLoadedChunks(this.thePlayer);
 		this.thePlayer.movementInput = new MovementInputFromOptions(this.options);
+		this.thePlayer.entityID = var8;
 		this.playerController.onRespawn(this.thePlayer);
 		this.preloadWorld("Respawning");
+		if(this.currentScreen instanceof GuiGameOver) {
+			this.displayGuiScreen((GuiScreen)null);
+		}
 	}
 
 	public static void startMainThread(String var0, String var1) {
--- /dev/null
+++ net/minecraft/src/Packet55BlockBreakAnimation.java
@@ -1,0 +1,72 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet55BlockBreakAnimation extends Packet {
+   private int id;
+   private int x;
+   private int y;
+   private int z;
+   private int progress;
+
+   public Packet55BlockBreakAnimation() {
+   }
+
+   public Packet55BlockBreakAnimation(int id, int x, int y, int z, int progress) {
+      this.id = id;
+      this.x = x;
+      this.y = y;
+      this.z = z;
+      this.progress = progress;
+   }
+
+   @Override
+   public void readPacketData(DataInputStream input) throws IOException {
+      this.id = input.readInt();
+      this.x = input.readInt();
+      this.y = input.readInt();
+      this.z = input.readInt();
+      this.progress = input.read();
+   }
+
+   @Override
+   public void writePacketData(DataOutputStream output) throws IOException {
+      output.writeInt(this.id);
+      output.writeInt(this.x);
+      output.writeInt(this.y);
+      output.writeInt(this.z);
+      output.write(this.progress);
+   }
+
+   @Override
+   public void processPacket(NetHandler handler) {
+      handler.handle55BlockBreakAnimation(this);
+   }
+
+   @Override
+   public int getPacketSize() {
+      return 13;
+   }
+
+   public int getPlayerId() {
+      return this.id;
+   }
+
+   public int getX() {
+      return this.x;
+   }
+
+   public int getY() {
+      return this.y;
+   }
+
+   public int getZ() {
+      return this.z;
+   }
+
+   public int getProgress() {
+      return this.progress;
+   }
+}
--- net/minecraft/src/Packet4UpdateTime.java
+++ net/minecraft/src/Packet4UpdateTime.java
@@ -11,7 +11,7 @@
 		this.time = var1.readLong();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeLong(this.time);
 	}
 
--- net/minecraft/src/Packet50PreChunk.java
+++ net/minecraft/src/Packet50PreChunk.java
@@ -9,13 +9,17 @@
 	public int yPosition;
 	public boolean mode;
 
+	public Packet50PreChunk() {
+		this.isChunkDataPacket = false;
+	}
+
 	public void readPacketData(DataInputStream var1) throws IOException {
 		this.xPosition = var1.readInt();
 		this.yPosition = var1.readInt();
 		this.mode = var1.read() != 0;
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.xPosition);
 		var1.writeInt(this.yPosition);
 		var1.write(this.mode ? 1 : 0);
--- /dev/null
+++ net/minecraft/src/Packet100OpenWindow.java
@@ -1,0 +1,34 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet100OpenWindow extends Packet {
+	public int windowId;
+	public int inventoryType;
+	public String windowTitle;
+	public int slotsCount;
+
+	public void processPacket(NetHandler var1) {
+		var1.func_20087_a(this);
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.windowId = var1.readByte();
+		this.inventoryType = var1.readByte();
+		this.windowTitle = var1.readUTF();
+		this.slotsCount = var1.readByte();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeByte(this.windowId);
+		var1.writeByte(this.inventoryType);
+		var1.writeUTF(this.windowTitle);
+		var1.writeByte(this.slotsCount);
+	}
+
+	public int getPacketSize() {
+		return 3 + this.windowTitle.length();
+	}
+}
--- net/minecraft/src/InventoryPlayer.java
+++ net/minecraft/src/InventoryPlayer.java
@@ -1,12 +1,11 @@
 package net.minecraft.src;
 
 public class InventoryPlayer implements IInventory {
-	public ItemStack[] mainInventory = new ItemStack[37];
+	public ItemStack[] mainInventory = new ItemStack[36];
 	public ItemStack[] armorInventory = new ItemStack[4];
-	public ItemStack[] craftingInventory = new ItemStack[4];
 	public int currentItem = 0;
-	private EntityPlayer player;
-	public ItemStack draggedItemStack;
+	public EntityPlayer player;
+	private ItemStack itemStack;
 	public boolean inventoryChanged = false;
 
 	public InventoryPlayer(EntityPlayer var1) {
@@ -14,7 +13,7 @@
 	}
 
 	public ItemStack getCurrentItem() {
-		return this.mainInventory[this.currentItem];
+		return this.currentItem < 9 && this.currentItem >= 0 ? this.mainInventory[this.currentItem] : null;
 	}
 
 	private int getInventorySlotContainItem(int var1) {
@@ -27,9 +26,9 @@
 		return -1;
 	}
 
-	private int storeItemStack(int var1) {
+	private int storeItemStack(ItemStack var1) {
 		for(int var2 = 0; var2 < this.mainInventory.length; ++var2) {
-			if(this.mainInventory[var2] != null && this.mainInventory[var2].itemID == var1 && this.mainInventory[var2].stackSize < this.mainInventory[var2].getMaxStackSize() && this.mainInventory[var2].stackSize < this.getInventoryStackLimit()) {
+			if(this.mainInventory[var2] != null && this.mainInventory[var2].itemID == var1.itemID && this.mainInventory[var2].isStackable() && this.mainInventory[var2].stackSize < this.mainInventory[var2].getMaxStackSize() && this.mainInventory[var2].stackSize < this.getInventoryStackLimit() && (!this.mainInventory[var2].getHasSubtypes() || this.mainInventory[var2].getItemDamage() == var1.getItemDamage())) {
 				return var2;
 			}
 		}
@@ -72,43 +71,45 @@
 
 	}
 
-	private int storePartialItemStack(int var1, int var2) {
-		int var3 = this.storeItemStack(var1);
-		if(var3 < 0) {
-			var3 = this.getFirstEmptyStack();
+	private int storePartialItemStack(ItemStack var1) {
+		int var2 = var1.itemID;
+		int var3 = var1.stackSize;
+		int var4 = this.storeItemStack(var1);
+		if(var4 < 0) {
+			var4 = this.getFirstEmptyStack();
 		}
 
-		if(var3 < 0) {
-			return var2;
+		if(var4 < 0) {
+			return var3;
 		} else {
-			if(this.mainInventory[var3] == null) {
-				this.mainInventory[var3] = new ItemStack(var1, 0);
-			}
-
-			int var4 = var2;
-			if(var2 > this.mainInventory[var3].getMaxStackSize() - this.mainInventory[var3].stackSize) {
-				var4 = this.mainInventory[var3].getMaxStackSize() - this.mainInventory[var3].stackSize;
-			}
-
-			if(var4 > this.getInventoryStackLimit() - this.mainInventory[var3].stackSize) {
-				var4 = this.getInventoryStackLimit() - this.mainInventory[var3].stackSize;
-			}
-
-			if(var4 == 0) {
-				return var2;
+			if(this.mainInventory[var4] == null) {
+				this.mainInventory[var4] = new ItemStack(var2, 0, var1.getItemDamage());
+			}
+
+			int var5 = var3;
+			if(var3 > this.mainInventory[var4].getMaxStackSize() - this.mainInventory[var4].stackSize) {
+				var5 = this.mainInventory[var4].getMaxStackSize() - this.mainInventory[var4].stackSize;
+			}
+
+			if(var5 > this.getInventoryStackLimit() - this.mainInventory[var4].stackSize) {
+				var5 = this.getInventoryStackLimit() - this.mainInventory[var4].stackSize;
+			}
+
+			if(var5 == 0) {
+				return var3;
 			} else {
-				var2 -= var4;
-				this.mainInventory[var3].stackSize += var4;
-				this.mainInventory[var3].animationsToGo = 5;
-				return var2;
+				var3 -= var5;
+				this.mainInventory[var4].stackSize += var5;
+				this.mainInventory[var4].animationsToGo = 5;
+				return var3;
 			}
 		}
 	}
 
 	public void decrementAnimations() {
 		for(int var1 = 0; var1 < this.mainInventory.length; ++var1) {
-			if(this.mainInventory[var1] != null && this.mainInventory[var1].animationsToGo > 0) {
-				--this.mainInventory[var1].animationsToGo;
+			if(this.mainInventory[var1] != null) {
+				this.mainInventory[var1].updateAnimation(this.player.worldObj, this.player, var1, this.currentItem == var1);
 			}
 		}
 
@@ -128,20 +129,24 @@
 	}
 
 	public boolean addItemStackToInventory(ItemStack var1) {
-		if(var1.itemDmg == 0) {
-			var1.stackSize = this.storePartialItemStack(var1.itemID, var1.stackSize);
-			if(var1.stackSize == 0) {
+		int var2;
+		if(var1.isItemDamaged()) {
+			var2 = this.getFirstEmptyStack();
+			if(var2 >= 0) {
+				this.mainInventory[var2] = ItemStack.copyItemStack(var1);
+				this.mainInventory[var2].animationsToGo = 5;
+				var1.stackSize = 0;
 				return true;
+			} else {
+				return false;
 			}
-		}
-
-		int var2 = this.getFirstEmptyStack();
-		if(var2 >= 0) {
-			this.mainInventory[var2] = var1;
-			this.mainInventory[var2].animationsToGo = 5;
-			return true;
 		} else {
-			return false;
+			do {
+				var2 = var1.stackSize;
+				var1.stackSize = this.storePartialItemStack(var1);
+			} while(var1.stackSize > 0 && var1.stackSize < var2);
+
+			return var1.stackSize < var2;
 		}
 	}
 
@@ -178,11 +183,6 @@
 			var3 = this.armorInventory;
 		}
 
-		if(var1 >= var3.length) {
-			var1 -= var3.length;
-			var3 = this.craftingInventory;
-		}
-
 		var3[var1] = var2;
 	}
 
@@ -216,36 +216,25 @@
 			}
 		}
 
-		for(var2 = 0; var2 < this.craftingInventory.length; ++var2) {
-			if(this.craftingInventory[var2] != null) {
-				var3 = new NBTTagCompound();
-				var3.setByte("Slot", (byte)(var2 + 80));
-				this.craftingInventory[var2].writeToNBT(var3);
-				var1.setTag(var3);
-			}
-		}
-
 		return var1;
 	}
 
 	public void readFromNBT(NBTTagList var1) {
 		this.mainInventory = new ItemStack[36];
 		this.armorInventory = new ItemStack[4];
-		this.craftingInventory = new ItemStack[4];
 
 		for(int var2 = 0; var2 < var1.tagCount(); ++var2) {
 			NBTTagCompound var3 = (NBTTagCompound)var1.tagAt(var2);
 			int var4 = var3.getByte("Slot") & 255;
-			if(var4 >= 0 && var4 < this.mainInventory.length) {
-				this.mainInventory[var4] = new ItemStack(var3);
-			}
-
-			if(var4 >= 80 && var4 < this.craftingInventory.length + 80) {
-				this.craftingInventory[var4 - 80] = new ItemStack(var3);
-			}
-
-			if(var4 >= 100 && var4 < this.armorInventory.length + 100) {
-				this.armorInventory[var4 - 100] = new ItemStack(var3);
+			ItemStack var5 = new ItemStack(var3);
+			if(var5.getItem() != null) {
+				if(var4 >= 0 && var4 < this.mainInventory.length) {
+					this.mainInventory[var4] = var5;
+				}
+
+				if(var4 >= 100 && var4 < this.armorInventory.length + 100) {
+					this.armorInventory[var4 - 100] = var5;
+				}
 			}
 		}
 
@@ -262,11 +251,6 @@
 			var2 = this.armorInventory;
 		}
 
-		if(var1 >= var2.length) {
-			var1 -= var2.length;
-			var2 = this.craftingInventory;
-		}
-
 		return var2[var1];
 	}
 
@@ -284,7 +268,7 @@
 	}
 
 	public boolean canHarvestBlock(Block var1) {
-		if(var1.material != Material.rock && var1.material != Material.iron && var1.material != Material.craftedSnow && var1.material != Material.snow) {
+		if(var1.material.getIsHarvestable()) {
 			return true;
 		} else {
 			ItemStack var2 = this.getStackInSlot(this.currentItem);
@@ -304,7 +288,7 @@
 		for(int var4 = 0; var4 < this.armorInventory.length; ++var4) {
 			if(this.armorInventory[var4] != null && this.armorInventory[var4].getItem() instanceof ItemArmor) {
 				int var5 = this.armorInventory[var4].getMaxDamage();
-				int var6 = this.armorInventory[var4].itemDmg;
+				int var6 = this.armorInventory[var4].getItemDamageForDisplay();
 				int var7 = var5 - var6;
 				var2 += var7;
 				var3 += var5;
@@ -323,9 +307,9 @@
 	public void damageArmor(int var1) {
 		for(int var2 = 0; var2 < this.armorInventory.length; ++var2) {
 			if(this.armorInventory[var2] != null && this.armorInventory[var2].getItem() instanceof ItemArmor) {
-				this.armorInventory[var2].damageItem(var1);
+				this.armorInventory[var2].damageItem(var1, this.player);
 				if(this.armorInventory[var2].stackSize == 0) {
-					this.armorInventory[var2].onItemDestroyedByUse(this.player);
+					this.armorInventory[var2].func_1097_a(this.player);
 					this.armorInventory[var2] = null;
 				}
 			}
@@ -355,49 +339,33 @@
 		this.inventoryChanged = true;
 	}
 
-	public boolean getInventoryEqual(InventoryPlayer var1) {
-		int var2;
-		for(var2 = 0; var2 < this.mainInventory.length; ++var2) {
-			if(!this.getItemStacksEqual(var1.mainInventory[var2], this.mainInventory[var2])) {
-				return false;
-			}
-		}
-
-		for(var2 = 0; var2 < this.armorInventory.length; ++var2) {
-			if(!this.getItemStacksEqual(var1.armorInventory[var2], this.armorInventory[var2])) {
-				return false;
-			}
-		}
-
-		for(var2 = 0; var2 < this.craftingInventory.length; ++var2) {
-			if(!this.getItemStacksEqual(var1.craftingInventory[var2], this.craftingInventory[var2])) {
-				return false;
-			}
-		}
-
-		return true;
-	}
-
-	private boolean getItemStacksEqual(ItemStack var1, ItemStack var2) {
-		return var1 == null && var2 == null ? true : (var1 != null && var2 != null ? var1.itemID == var2.itemID && var1.stackSize == var2.stackSize && var1.itemDmg == var2.itemDmg : false);
-	}
-
-	public InventoryPlayer copyInventory() {
-		InventoryPlayer var1 = new InventoryPlayer((EntityPlayer)null);
-
-		int var2;
-		for(var2 = 0; var2 < this.mainInventory.length; ++var2) {
-			var1.mainInventory[var2] = this.mainInventory[var2] != null ? this.mainInventory[var2].copy() : null;
-		}
-
-		for(var2 = 0; var2 < this.armorInventory.length; ++var2) {
-			var1.armorInventory[var2] = this.armorInventory[var2] != null ? this.armorInventory[var2].copy() : null;
-		}
-
-		for(var2 = 0; var2 < this.craftingInventory.length; ++var2) {
-			var1.craftingInventory[var2] = this.craftingInventory[var2] != null ? this.craftingInventory[var2].copy() : null;
-		}
-
-		return var1;
+	public void setItemStack(ItemStack var1) {
+		this.itemStack = var1;
+		this.player.onItemStackChanged(var1);
+	}
+
+	public ItemStack getItemStack() {
+		return this.itemStack;
+	}
+
+	public boolean canInteractWith(EntityPlayer var1) {
+		return this.player.isDead ? false : var1.getDistanceSqToEntity(this.player) <= 64.0D;
+	}
+
+	public boolean func_28018_c(ItemStack var1) {
+		int var2;
+		for(var2 = 0; var2 < this.armorInventory.length; ++var2) {
+			if(this.armorInventory[var2] != null && this.armorInventory[var2].isStackEqual(var1)) {
+				return true;
+			}
+		}
+
+		for(var2 = 0; var2 < this.mainInventory.length; ++var2) {
+			if(this.mainInventory[var2] != null && this.mainInventory[var2].isStackEqual(var1)) {
+				return true;
+			}
+		}
+
+		return false;
 	}
 }
--- net/minecraft/src/EntityPlayerSP.java
+++ net/minecraft/src/EntityPlayerSP.java
@@ -50,6 +50,11 @@
 		super.readEntityFromNBT(var1);
 		this.score = var1.getInteger("Score");
 	}
+	
+	public void closeScreen() {
+		super.closeScreen();
+		this.mc.displayGuiScreen((GuiScreen)null);
+	}
 
 	public void displayGUIChest(IInventory var1) {
 		this.mc.displayGuiScreen(new GuiChest(this.inventory, var1));
@@ -59,30 +64,14 @@
 		this.mc.displayGuiScreen(new GuiEditSign(var1));
 	}
 
-	public void displayWorkbenchGUI() {
-		this.mc.displayGuiScreen(new GuiCrafting(this.inventory));
+	public void displayWorkbenchGUI(int var1, int var2, int var3) {
+		this.mc.displayGuiScreen(new GuiCrafting(this.inventory, this.worldObj, var1, var2, var3));
 	}
 
 	public void displayGUIFurnace(TileEntityFurnace var1) {
 		this.mc.displayGuiScreen(new GuiFurnace(this.inventory, var1));
 	}
 
-	public void attackEntity(Entity var1) {
-		int var2 = this.inventory.getDamageVsEntity(var1);
-		if(var2 > 0) {
-			var1.attackEntityFrom(this, var2);
-			ItemStack var3 = this.getCurrentEquippedItem();
-			if(var3 != null && var1 instanceof EntityLiving) {
-				var3.hitEntity((EntityLiving)var1);
-				if(var3.stackSize <= 0) {
-					var3.onItemDestroyedByUse(this);
-					this.destroyCurrentEquippedItem();
-				}
-			}
-		}
-
-	}
-
 	public void onItemPickup(Entity var1, int var2) {
 		this.mc.effectRenderer.addEffect(new EntityPickupFX(this.mc.theWorld, var1, this, -0.5F));
 	}
@@ -91,20 +80,6 @@
 		return this.inventory.getTotalArmorValue();
 	}
 
-	public void interactWithEntity(Entity var1) {
-		if(!var1.interact(this)) {
-			ItemStack var2 = this.getCurrentEquippedItem();
-			if(var2 != null && var1 instanceof EntityLiving) {
-				var2.useItemOnEntity((EntityLiving)var1);
-				if(var2.stackSize <= 0) {
-					var2.onItemDestroyedByUse(this);
-					this.destroyCurrentEquippedItem();
-				}
-			}
-
-		}
-	}
-
 	public void sendChatMessage(String var1) {
 	}
 
@@ -113,5 +88,26 @@
 
 	public boolean isSneaking() {
 		return this.movementInput.sneak;
+	}
+	
+	public void setHealth(int var1) {
+		int var2 = this.health - var1;
+		if(var2 <= 0) {
+			this.health = var1;
+			if(var2 < 0) {
+				this.heartsLife = this.heartsHalvesLife / 2;
+			}
+		} else {
+			this.somethingHealth = var2;
+			this.prevHealth = this.health;
+			this.heartsLife = this.heartsHalvesLife;
+			this.damageEntity(var2);
+			this.hurtTime = this.maxHurtTime = 10;
+		}
+
+	}
+	
+	public void respawnPlayer() {
+		this.mc.respawn();
 	}
 }
--- /dev/null
+++ net/minecraft/src/Packet39AttachEntity.java
@@ -1,0 +1,28 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet39AttachEntity extends Packet {
+	public int entityId;
+	public int vehicleEntityId;
+
+	public int getPacketSize() {
+		return 8;
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.entityId = var1.readInt();
+		this.vehicleEntityId = var1.readInt();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.entityId);
+		var1.writeInt(this.vehicleEntityId);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_6497_a(this);
+	}
+}
--- net/minecraft/src/Packet52MultiBlockChange.java
+++ net/minecraft/src/Packet52MultiBlockChange.java
@@ -32,7 +32,7 @@
 		var1.readFully(this.metadataArray);
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.xPosition);
 		var1.writeInt(this.zPosition);
 		var1.writeShort((short)this.size);
--- /dev/null
+++ net/minecraft/src/Packet61DoorChange.java
@@ -1,0 +1,37 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet61DoorChange extends Packet {
+	public int field_28050_a;
+	public int field_28049_b;
+	public int field_28053_c;
+	public int field_28052_d;
+	public int field_28051_e;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.field_28050_a = var1.readInt();
+		this.field_28053_c = var1.readInt();
+		this.field_28052_d = var1.readByte();
+		this.field_28051_e = var1.readInt();
+		this.field_28049_b = var1.readInt();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.field_28050_a);
+		var1.writeInt(this.field_28053_c);
+		var1.writeByte(this.field_28052_d);
+		var1.writeInt(this.field_28051_e);
+		var1.writeInt(this.field_28049_b);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_28115_a(this);
+	}
+
+	public int getPacketSize() {
+		return 20;
+	}
+}
